!= Program ArareInitData
!
! Authors::   SUGIYAMA Ko-ichiro (̰ϯ), ODAKA Masatsugu ()
! Version::   $Id: arare_init-data.f90,v 1.8 2011-06-03 16:31:45 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
! ϳإǥ deepconv/arare. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ϤϽవ̷.
!
!== Future Plans
!
!

program ArareInitData
  !
  !ϳإǥ deepconv/arare. 
  !

  !----- ⥸塼ɤ߹ ------

  !-----   , ʸ   ----
  use dc_types,       only : STRING, DP
  use dc_string,      only : StoA
  use gtool_history,  only : HistoryPut

  !-----   å   -----
  use dc_message,     only: MessageNotify

  !  ޥɥ饤
  use argset,        only : argset_init  

  !  MPI ν
  !  Initialize MPI wrapper
  !
  use mpi_wrapper,   only : MPIWrapperInit, MPIWrapperFinalize

  !-----    ⥸塼   -----
  !  ϥե̾⥸塼
  use fileset,    only : fileset_init

  !  ʻ⥸塼 
  use gridset, only : gridset_init, &
    &                       imin, imax, jmin, jmax, kmin, kmax, ncmax

  !  ܾ⥸塼
  use basicset,      only : basicset_init

  use axesset,       only : axesset_init

  use constants,     only : constants_init, molwtdry, &
    &                       pressbasis, gasrdry, cpdry, cvdry

  !  롼⥸塼
  use composition,      only: composition_init, molwtwet

  ! ط׻
  use ChemCalc, only: ChemCalc_init

  !  Ŭѥ⥸塼
  use setmargin

  use initialdata_basic, only: &
    &                        initialdata_basic_nml, initialdata_basic_dry, &
    &                        initialdata_basic_moist, initialdata_basic_strat, &
    &                        initialdata_basic_isothermal, &
    &                        ID_FlaginitdataBasic, ID_FlaginitDataBasic_dry, &
    &                        ID_FlaginitDataBasic_moist , ID_FlaginitDataBasic_isothermal
  use initialdata_disturb, only: &
    &  initialdata_disturb_nml, initialdata_disturb_random,  &
    &  initialdata_disturb_gaussXZ, initialdata_disturb_gaussXY, initialdata_disturb_gaussXYZ, &
    &  initialdata_disturb_dryregion, initialdata_disturb_moist, &
    &  ID_FlaginitdataPTemp, ID_FlaginitdataExner, ID_FlaginitdataQMix, &
    &  ID_Flaginitdata_GaussXY, ID_Flaginitdata_GaussXZ, &
    &  ID_Flaginitdata_GaussXYZ, ID_Flaginitdata_random, &
    &  ID_FlaginitdataQMix_dryregion, ID_FlaginitdataQMix_moist

  !-----    ϥ⥸塼   -----
  !  ꥹȥեϥ⥸塼
  use RestartFileIO, only : ReStartFileIO_Init, ReStartFileIO_Finalize, rstat
  use Arare4FileIO,  only : Arare4FileIO_Init, Arare4FileIO_Var_Get, Arare4FileIO_BZ_Get, &
    &                       Arare4FileIO_MMC_Var_Get, Arare4FileIO_MMC_BZ_Get

  !ۤηػ
  implicit none

  !ѿ
  real(DP), allocatable :: pyz_VelX(:,:,:)
  real(DP), allocatable :: xqz_VelY(:,:,:)
  real(DP), allocatable :: xyr_VelZ(:,:,:)
  real(DP), allocatable :: xyz_Exner(:,:,:)
  real(DP), allocatable :: xyz_PTemp(:,:,:)
  real(DP), allocatable :: xyz_Km(:,:,:)
  real(DP), allocatable :: xyz_Kh(:,:,:)
  real(DP), allocatable :: xyz_CDens(:,:,:)
  real(DP), allocatable :: xyzf_QMix(:,:,:,:)
  real(DP), allocatable :: xyz_DensBZ(:,:,:)
  real(DP), allocatable :: xyz_PressBZ(:,:,:)
  real(DP), allocatable :: xyz_ExnerBZ(:,:,:)
  real(DP), allocatable :: xyz_TempBZ(:,:,:)
  real(DP), allocatable :: xyz_PTempBZ(:,:,:)
  real(DP), allocatable :: xyz_VelSoundBZ(:,:,:)
  real(DP), allocatable :: xyzf_QMixBZ(:,:,:,:)
  real(DP), allocatable :: xyz_EffMolWtBZ(:,:,:)
  real(DP), allocatable :: z_TempBZ(:)
  real(DP), allocatable :: z_PressBZ(:)
  real(DP), allocatable :: xyzf_MolFr(:,:,:,:)
  real(DP), allocatable :: za_MolFr(:,:)
  real(DP), allocatable :: xyzf_QMixDivMolWt(:,:,:,:)
  real(DP)              :: Time
  integer               :: i, j, s
  character(STRING)     :: cfgfile = ""
  integer            :: ID_FlaginitData = 0
  integer, parameter :: ID_FlaginitData_default = 1
  integer, parameter :: ID_FlaginitData_Yamasaki1983 = 2
  integer, parameter :: ID_FlaginitData_Takemi2007 = 3
  integer, parameter :: ID_FlaginitData_arare4 = 4
  integer, parameter :: ID_FlaginitData_arare4_mmc = 5
  
  ! MPI
  !
  call MPIWrapperInit

  !NAMELIST ե̾ɤ߹
  !
  call argset_init(cfgfile) !(out)

  ! nml Ф
  !
  call deepconvInitialData(cfgfile)
  
  !ʻν
  !  NAMELIST , ʻ׻
  !
  call gridset_init(cfgfile)
  
  ! ط׻롼ν
  ! Initialization of chemical routines.
  !
  call chemcalc_init( )
  
  ! ξν
  ! Initialization of axis variables.
  !
  call axesset_init( cfgfile ) !(in)

  ! ξν
  ! Initialization of constant variables.
  !
  call constants_init( cfgfile ) !(in)

  ! ξν
  ! Initialization of constant variables.
  !
  call composition_init( cfgfile ) !(in)
  
  
  ! I/O ե̾ν
  ! Initialization of output file name. 
  !
  call fileset_init( cfgfile ) ! (in)
    
  ! ͭѿν
  ! Initialization of common variables for moist process.
  !
!  call composition_init( cfgfile )

  !ѿν. ȤꤢͤꤵƤ. 
  !
  call ArareAlloc

  !---------------------------------------------------------------  
  ! ܾ, . 
  !
  Time = 0.0d0

  call MessageNotify( "M", "main", "Making Initial data...." )

  select case(ID_FlaginitData)      
    
  case (ID_FlaginitData_arare4)
    call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
    call arare4fileio_init(cfgfile)
    call Arare4fileio_Var_Get( &
      & pyz_VelX,     & ! (out)
      & xqz_VelY,     & ! (out)
      & xyr_VelZ,     & ! (out)
      & xyz_PTemp,    & ! (out)
      & xyz_Exner,    & ! (out)
      & xyzf_QMix,    & ! (out)
      & xyz_Km,       & ! (out)
      & xyz_Kh,       & ! (out)
      & xyz_CDens   )   ! (out)
    call Arare4fileio_BZ_Get( &
      & xyz_PressBZ,   &
      & xyz_ExnerBZ,   &
      & xyz_TempBZ,    &
      & xyz_PTempBZ, &
      & xyz_DensBZ,    &
      & xyz_VelSoundBZ,&
      & xyzf_QMixBZ,  &
      & xyz_EffMolWtBZ &
      & )

  case (ID_FlaginitData_arare4_mmc)
    call MessageNotify( "M", "main", "Making Initial data using arare4 files ...." )
    call arare4fileio_init(cfgfile)
    call Arare4fileio_MMC_Var_Get( &
      & pyz_VelX,     & ! (out)
      & xqz_VelY,     & ! (out)
      & xyr_VelZ,     & ! (out)
      & xyz_PTemp,    & ! (out)
      & xyz_Exner,    & ! (out)
      & xyzf_QMix,    & ! (out)
      & xyz_Km,       & ! (out)
      & xyz_Kh,       & ! (out)
      & xyz_CDens   )   ! (out)
    call Arare4fileio_MMC_BZ_Get( &
      & xyz_PressBZ,   &
      & xyz_ExnerBZ,   &
      & xyz_TempBZ,    &
      & xyz_PTempBZ, &
      & xyz_DensBZ,    &
      & xyz_VelSoundBZ,&
      & xyzf_QMixBZ,  &
      & xyz_EffMolWtBZ &
      & )

  case (ID_FlaginitData_default)
    call MessageNotify( "M", "main", "Making Initial data by default setting...." )
    call initialdata_basic_nml(cfgfile)
    call initialdata_disturb_nml(cfgfile)
    
    select case(ID_FlaginitdataBasic)
      
    case(ID_FlaginitDataBasic_isothermal) ! ǮŪʽ
      call MessageNotify( "M", "main", "Making Initial data (basic) named IsoThermal..." )
      call initialdata_basic_isothermal( z_TempBZ, z_PressBZ, za_MolFr ) !(out)

    case(ID_FlaginitDataBasic_dry) ! ǮŪʽ
      call MessageNotify( "M", "main", "Making Initial data (basic) named DRY..." )
      call initialdata_basic_dry( z_TempBZ, z_PressBZ, za_MolFr ) !(out)
!      call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
      
    case(ID_FlaginitDataBasic_moist) ! ǮŪʽ
      call MessageNotify( "M", "main", "Making Initial data (basic) named MOIST..." )
      call initialdata_basic_moist( z_TempBZ, z_PressBZ, za_MolFr ) !(out)
!      call initialdata_basic_strat( z_TempBZ, z_PressBZ ) !(inout)
      
    end select

    ! Ĥδܾͤ
    call DetermineBZ      
    
    select case(ID_FlaginitdataPTemp)
      
    case(ID_Flaginitdata_GaussXY)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
      call initialdata_disturb_gaussXY(xyz_PTemp)
      
    case(ID_Flaginitdata_GaussXZ)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
      call initialdata_disturb_gaussXZ(xyz_PTemp)
      
    case(ID_Flaginitdata_GaussXYZ)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
      call initialdata_disturb_gaussXYZ(xyz_PTemp)
      
    case(ID_Flaginitdata_random)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named random..." )
      call initialdata_disturb_random(xyz_PTemp)
      
    end select

    call SetMargin_xyz( xyz_PTemp )

    select case(ID_FlaginitdataExner)
      
    case(ID_Flaginitdata_GaussXY)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
      call initialdata_disturb_gaussXY(xyz_Exner)
      
    case(ID_Flaginitdata_GaussXZ)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
      call initialdata_disturb_gaussXZ(xyz_Exner)
      
    case(ID_Flaginitdata_GaussXYZ)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
      call initialdata_disturb_gaussXYZ(xyz_Exner)
    end select

    call SetMargin_xyz( xyz_Exner )
    
    select case(ID_FlaginitdataQMix)
      
    case(ID_Flaginitdata_GaussXY)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXY..." )
      call initialdata_disturb_gaussXY(xyzf_QMix(:,:,:,1))
      
    case(ID_Flaginitdata_GaussXZ)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXZ..." )
      call initialdata_disturb_gaussXZ(xyzf_QMix(:,:,:,1))
      
    case(ID_Flaginitdata_GaussXYZ)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named GaussXYZ..." )
      call initialdata_disturb_gaussXYZ(xyzf_QMix(:,:,:,1))

    case(ID_FlaginitdataQMix_dryregion)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named DryRegion..." )
      call initialdata_disturb_dryregion(xyzf_QMix)
      
    case(ID_FlaginitdataQMix_moist)
      call MessageNotify( "M", "main", "Making Initial data (disturb) named MOIST..." )
      call initialdata_disturb_moist(xyzf_QMix)
      
    end select

    call SetMargin_xyzf( xyzf_QMix )
    
  case(ID_Flaginitdata_Yamasaki1983) ! Yamasaki(1983)β٤м٤δ¬ͤѤ 
    call MessageNotify( "M", "main", "Making Initial data named Yamasaki1983..." )
!      call initialdata_yamasaki1983_nml
!      ! ܾ
!      call initialdata_yamasaki1983_set( z_TempBZ, z_PressBZ, za_MolFr )
!
!      ! Ĥδܾͤ
!      call DetermineBZ            
!
!      ! ʲʬ֤ۤ
!      call initialdata_disturb_random()

  case(ID_Flaginitdata_Takemi2007) ! Takemi(2007)δܾѤ
    call MessageNotify( "M", "main", "Making Initial data named Takemi2007..." )
!      call initialdata_takemi2007_nml
!
!      ! ܾ
!      call initialdata_takemi2007_basic( z_TempBZ, z_PressBZ, za_MolFr )
!
!      ! Ĥδܾͤ
!      call DetermineBZ      
!
!      ! ®ʬ
!      call initialdata_takemi2007_wind( z_TempBZ, z_PressBZ, za_MolFr ) 
!
!      ! ʲʬ֤ۤ
!      call initialdata_disturb_random()
  end select
  
  !Τͤ  
  !
  call SetMargin_xyz( xyz_PTemp )
  
  !Τͤ
  !
  call SetMargin_xyzf( xyzf_QMix )

  call MessageNotify( "M", "main", "Output variables into netCDF file..." )
  
  !---------------------------------
  ! ꥹȥե. ܾȾ. 
  !
  call ReStartFileIO_Init(cfgfile)

  call HistoryPut( 't',     Time,      rstat)
  call HistoryPut( 'VelX',  pyz_VelX,  rstat)
  call HistoryPut( 'VelY',  xqz_VelY,  rstat)
  call HistoryPut( 'VelZ',  xyr_VelZ,  rstat)
  call HistoryPut( 'Exner', xyz_Exner, rstat)
  call HistoryPut( 'PTemp', xyz_PTemp, rstat)
  call HistoryPut( 'Km',    xyz_Km,    rstat)
  call HistoryPut( 'Kh',    xyz_Kh,    rstat)
  call HistoryPut( 'QMix',  xyzf_QMix, rstat)    
  call HistoryPut( 'CDens', xyz_CDens, rstat)    

  !-------------------------------------------------------------
  ! ܾΥե
  !
  call HistoryPut( 'DensBZ',   xyz_DensBZ     , rstat)
  call HistoryPut( 'ExnerBZ',  xyz_ExnerBZ    , rstat)
  call HistoryPut( 'PTempBZ',  xyz_PTempBZ  , rstat)
  call HistoryPut( 'VelSoundBZ', xyz_VelSoundBZ , rstat)
  call HistoryPut( 'TempBZ',    xyz_TempBZ     , rstat)
  call HistoryPut( 'PressBZ',   xyz_PressBZ    , rstat)
  call HistoryPut( 'QMixBZ',    xyzf_QMixBZ  , rstat)
  call HistoryPut( 'EffMolWtBZ', xyz_EffMolWtBZ, rstat)
  
  call ReStartFileIO_Finalize

  !----------------------------------------------------
  ! MPI END
  !
  call MPIWrapperFinalize
  
contains

  subroutine ArareAlloc
    !
    !Ȥ, , ͤȤƥ.
    !

    !ۤηػ
    implicit none

    !
    allocate( pyz_VelX(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xqz_VelY(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyr_VelZ(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyz_Exner(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyz_PTemp(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyz_Km(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyz_Kh(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyz_CDens(imin:imax, jmin:jmax, kmin:kmax) )
    allocate( xyzf_QMix(imin:imax, jmin:jmax, kmin:kmax, ncmax) )

    allocate( xyz_DensBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( xyz_PressBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( xyz_ExnerBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( xyz_TempBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( xyz_PTempBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( xyz_VelSoundBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( xyzf_QMixBZ(imin:imax,jmin:jmax,kmin:kmax,ncmax))
    allocate( xyz_EffMolWtBZ(imin:imax,jmin:jmax,kmin:kmax))
    allocate( z_TempBZ(kmin:kmax))
    allocate( z_PressBZ(kmin:kmax))
    allocate( xyzf_MolFr(imin:imax, jmin:jmax, kmin:kmax, ncmax))
    allocate( za_MolFr(kmin:kmax, ncmax))
    allocate( xyzf_QMixDivMolWt(imin:imax,jmin:jmax,kmin:kmax, ncmax))

    pyz_VelX = 0.0d0
    xqz_VelY = 0.0d0
    xyr_VelZ = 0.0d0
    xyz_PTemp = 0.0d0
    xyz_Exner = 0.0d0
    xyz_Km = 0.0d0
    xyz_Kh = 0.0d0
    xyz_CDens = 0.0d0
    xyzf_QMix = 0.0d0

    xyz_DensBZ = 0.0d0
    xyz_PressBZ = 0.0d0
    xyz_ExnerBZ = 0.0d0
    xyz_TempBZ = 0.0d0
    xyz_PTempBZ = 0.0d0
    xyz_VelSoundBZ = 0.0d0
    xyzf_QMixBZ = 0.0d0
    xyz_EffMolWtBZ  = 0.0d0
    z_TempBZ  = 0.0d0
    z_PressBZ = 0.0d0
    xyzf_MolFr = 0.0d0
    za_MolFr = 0.0d0 
    xyzf_QMixDivMolWt = 0.0d0

  end subroutine ArareAlloc
    

  subroutine DetermineBZ

    ! 3 ˳Ǽ
    do j = jmin, jmax
      do i = imin, imax
        xyz_TempBZ(i,j,:)  = z_TempBZ(:)  
        xyz_PressBZ(i,j,:) = z_PressBZ(:)
      end do
    end do
    
    !Τͤ
    !
    call SetMargin_xyz( xyz_TempBZ )
    call SetMargin_xyz( xyz_PressBZ)
       

    !---------------------------------------------------------------
    ! 
    !---------------------------------------------------------------
    !ʿˤϰ
    do i = imin, imax
      do j = jmin, jmax
        xyzf_MolFr(i,j,:,:) = za_MolFr
      end do
    end do
 
    !Υ򺮹Ѵ
    do s = 1, ncmax
      xyzf_QMixBZ(:,:,:,s) = xyzf_MolFr(:,:,:,s) * MolWtWet(s) / MolWtDry
    end do
    
    !  !ͤʤꤹʤ褦˺ͤͿ
    !  where (xyzf_QMixBZ <= 1.0d-20 )
    !    xyzf_QMixBZ = 1.0d-20
    !  end where
    
    !Τͤ
    !
    call SetMargin_xyzf( xyzf_QMixBZ )
    
    !---------------------------------------------------------------
    ! ʬ̤θ
    !---------------------------------------------------------------
    do s = 1, ncmax
      xyzf_QMixDivMolWt(:,:,:,s) = xyzf_QMixBZ(:,:,:,s) / MolWtWet(s)
    end do
    
    xyz_EffMolWtBZ = &
      & (1.0d0 + sum(xyzf_QMixBZ,4) ) &
      & / ( MolWtDry * ((1.0d0 / MolWtDry) + sum(xyzf_QMixDivMolWt,4)) )
    
    !Τͤ  
    !
    call SetMargin_xyz( xyz_EffMolWtBZ )
    
    !---------------------------------------------------------------    
    ! 
    !---------------------------------------------------------------
    xyz_PTempBZ = &
      & xyz_TempBZ * (PressBasis / xyz_PressBZ) ** (GasRDry / CpDry) 

    !Τͤ  
    !
    call SetMargin_xyz( xyz_PTempBZ )
    
    !---------------------------------------------------------------    
    ! ʡؿ
    !---------------------------------------------------------------
    xyz_ExnerBZ = xyz_TempBZ / xyz_PTempBZ    
    
    !Τͤ
    !
    call SetMargin_xyz( xyz_ExnerBZ )

    !---------------------------------------------------------------    
    ! ̩
    !---------------------------------------------------------------
    xyz_DensBZ = &
      & PressBasis * (xyz_ExnerBZ ** (CvDry / GasRDry)) &
      &  / (GasRDry * xyz_PTempBZ / xyz_EffMolWtBZ)
    
    !Τͤ
    !
    call SetMargin_xyz( xyz_DensBZ )
    
    !---------------------------------------------------------------    
    ! ®
    !---------------------------------------------------------------
    xyz_VelSoundBZ = &
      & sqrt ( &
      &   CpDry * GasRDry * xyz_ExnerBZ * xyz_PTempBZ &
      &   / (CvDry * xyz_EffMolWtBZ) &
      & )
    
    !Τͤ
    !
    call SetMargin_xyz( xyz_VelSoundBZ )
   
    !----------------------------------------------------------
    ! BasicSet ⥸塼ͤ
    !----------------------------------------------------------
    call BasicSet_Init(                           &
      & xyz_PressBZ, xyz_ExnerBZ, xyz_TempBZ,     &
      & xyz_PTempBZ, xyz_DensBZ,  xyz_VelSoundBZ, &
      & xyzf_QMixBZ, xyz_EffMolWtBZ )
    
  end subroutine DetermineBZ


  subroutine deepconvInitialdata( cfgfile )

    use dc_iounit,     only : FileOpen    

    implicit none

    character(STRING), intent(in) :: cfgfile
    character(STRING)             :: FlaginitData = ""
    integer                       :: unit     !ֹ

    NAMELIST /initialdata_nml/ FlaginitData

    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=initialdata_nml)
    close(unit)

    if (FlaginitData == "default") then 
      ID_FlaginitData = ID_FlaginitData_default
    elseif (FlaginitData == "Yamasaki1983") then
      ID_FlaginitData = ID_FlaginitData_Yamasaki1983
    elseif (FlaginitData == "Takemi2007") then
      ID_FlaginitData = ID_FlaginitData_Takemi2007
    elseif (FlaginitData == "arare4") then
      ID_FlaginitData = ID_FlaginitData_arare4
    elseif (FlaginitData == "arare4_mmc") then
      ID_FlaginitData = ID_FlaginitData_arare4_mmc
    end if

  end subroutine deepconvInitialdata

end program ArareInitData
